//
// InstitutionsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class InstitutionsAPI: APIBase {
    /**
     Institution Curation Review
     
     - parameter curationId: (path) ID of the curation 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountInstitutionCuration(curationId curationId: Int64, completion: ((data: CurationDetail?, error: ErrorType?) -> Void)) {
        accountInstitutionCurationWithRequestBuilder(curationId: curationId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Institution Curation Review
     - GET /account/institution/review/{curationId}
     - Retrieve a certain curation review by its ID
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter curationId: (path) ID of the curation 

     - returns: RequestBuilder<CurationDetail> 
     */
    public class func accountInstitutionCurationWithRequestBuilder(curationId curationId: Int64) -> RequestBuilder<CurationDetail> {
        var path = "/account/institution/review/{curationId}"
        path = path.stringByReplacingOccurrencesOfString("{curation_id}", withString: "\(curationId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<CurationDetail>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Institution Curation Review Comments
     
     - parameter curationId: (path) ID of the curation 
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountInstitutionCurationComments(curationId curationId: Int64, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: CurationComment?, error: ErrorType?) -> Void)) {
        accountInstitutionCurationCommentsWithRequestBuilder(curationId: curationId, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Institution Curation Review Comments
     - GET /account/institution/review/{curationId}/comments
     - Retrieve a certain curation review's comments.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter curationId: (path) ID of the curation 
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<CurationComment> 
     */
    public class func accountInstitutionCurationCommentsWithRequestBuilder(curationId curationId: Int64, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<CurationComment> {
        var path = "/account/institution/review/{curationId}/comments"
        path = path.stringByReplacingOccurrencesOfString("{curation_id}", withString: "\(curationId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<CurationComment>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     POST Institution Curation Review Comment
     
     - parameter curationId: (path) ID of the curation 
     - parameter curationComment: (body) The content/value of the comment. 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountInstitutionCurationComments_0(curationId curationId: Int64, curationComment: CurationCommentCreate, completion: ((error: ErrorType?) -> Void)) {
        accountInstitutionCurationComments_0WithRequestBuilder(curationId: curationId, curationComment: curationComment).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     POST Institution Curation Review Comment
     - POST /account/institution/review/{curationId}/comments
     - Add a new comment to the review.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter curationId: (path) ID of the curation 
     - parameter curationComment: (body) The content/value of the comment. 

     - returns: RequestBuilder<Void> 
     */
    public class func accountInstitutionCurationComments_0WithRequestBuilder(curationId curationId: Int64, curationComment: CurationCommentCreate) -> RequestBuilder<Void> {
        var path = "/account/institution/review/{curationId}/comments"
        path = path.stringByReplacingOccurrencesOfString("{curation_id}", withString: "\(curationId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = curationComment.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     * enum for parameter status
     */
    public enum Status_accountInstitutionCurations: String { 
        case Pending = "pending"
        case Approved = "approved"
        case Rejected = "rejected"
        case Closed = "closed"
    }

    /**
     Institution Curation Reviews
     
     - parameter groupId: (query) Filter by the group ID (optional)
     - parameter articleId: (query) Retrieve the reviews for this article (optional)
     - parameter status: (query) Filter by the status of the review (optional)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountInstitutionCurations(groupId groupId: Int64? = nil, articleId: Int64? = nil, status: Status_accountInstitutionCurations? = nil, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: Curation?, error: ErrorType?) -> Void)) {
        accountInstitutionCurationsWithRequestBuilder(groupId: groupId, articleId: articleId, status: status, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Institution Curation Reviews
     - GET /account/institution/reviews
     - Retrieve a list of curation reviews for this institution
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter groupId: (query) Filter by the group ID (optional)
     - parameter articleId: (query) Retrieve the reviews for this article (optional)
     - parameter status: (query) Filter by the status of the review (optional)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<Curation> 
     */
    public class func accountInstitutionCurationsWithRequestBuilder(groupId groupId: Int64? = nil, articleId: Int64? = nil, status: Status_accountInstitutionCurations? = nil, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<Curation> {
        let path = "/account/institution/reviews"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "group_id": groupId?.encodeToJSON(),
            "article_id": articleId?.encodeToJSON(),
            "status": status?.rawValue,
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Curation>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private account institution group custom fields
     
     - parameter groupId: (query) Group_id (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func customFieldsList(groupId groupId: Int64? = nil, completion: ((data: [ShortCustomField]?, error: ErrorType?) -> Void)) {
        customFieldsListWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private account institution group custom fields
     - GET /account/institution/custom_fields
     - Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter groupId: (query) Group_id (optional)

     - returns: RequestBuilder<[ShortCustomField]> 
     */
    public class func customFieldsListWithRequestBuilder(groupId groupId: Int64? = nil) -> RequestBuilder<[ShortCustomField]> {
        let path = "/account/institution/custom_fields"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "group_id": groupId?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ShortCustomField]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Custom fields values files upload
     
     - parameter customFieldId: (path) Custom field identifier 
     - parameter externalFile: (form) CSV file to be uploaded (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func customFieldsUpload(customFieldId customFieldId: Int64, externalFile: NSURL? = nil, completion: ((data: AnyObject?, error: ErrorType?) -> Void)) {
        customFieldsUploadWithRequestBuilder(customFieldId: customFieldId, externalFile: externalFile).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Custom fields values files upload
     - POST /account/institution/custom_fields/{customFieldId}/items/upload
     - Uploads a CSV containing values for a specific custom field of type <b>dropdown_large_list</b>. More details in the <a href=\"#custom_fields\">Custom Fields section</a>
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter customFieldId: (path) Custom field identifier 
     - parameter externalFile: (form) CSV file to be uploaded (optional)

     - returns: RequestBuilder<AnyObject> 
     */
    public class func customFieldsUploadWithRequestBuilder(customFieldId customFieldId: Int64, externalFile: NSURL? = nil) -> RequestBuilder<AnyObject> {
        var path = "/account/institution/custom_fields/{customFieldId}/items/upload"
        path = path.stringByReplacingOccurrencesOfString("{custom_field_id}", withString: "\(customFieldId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "external_file": externalFile
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<AnyObject>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Public Institution Articles
     
     - parameter institutionStringId: (path)  
     - parameter resourceId: (query)  
     - parameter filename: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func institutionArticles(institutionStringId institutionStringId: String, resourceId: String, filename: String, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        institutionArticlesWithRequestBuilder(institutionStringId: institutionStringId, resourceId: resourceId, filename: filename).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Institution Articles
     - GET /institutions/{institutionStringId}/articles/filter-by
     - Returns a list of articles belonging to the institution
     - examples: [{contentType=application/json, example={}}]
     
     - parameter institutionStringId: (path)  
     - parameter resourceId: (query)  
     - parameter filename: (query)  

     - returns: RequestBuilder<[Article]> 
     */
    public class func institutionArticlesWithRequestBuilder(institutionStringId institutionStringId: String, resourceId: String, filename: String) -> RequestBuilder<[Article]> {
        var path = "/institutions/{institutionStringId}/articles/filter-by"
        path = path.stringByReplacingOccurrencesOfString("{institution_string_id}", withString: "\(institutionStringId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "resource_id": resourceId,
            "filename": filename
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Institution HRfeed Upload
     
     - parameter hrfeed: (form) You can find an example in the Hr Feed section (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func institutionHrfeedUpload(hrfeed hrfeed: NSURL? = nil, completion: ((data: ResponseMessage?, error: ErrorType?) -> Void)) {
        institutionHrfeedUploadWithRequestBuilder(hrfeed: hrfeed).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Institution HRfeed Upload
     - POST /institution/hrfeed/upload
     - More info in the <a href=\"#hr_feed\">HR Feed section</a>
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter hrfeed: (form) You can find an example in the Hr Feed section (optional)

     - returns: RequestBuilder<ResponseMessage> 
     */
    public class func institutionHrfeedUploadWithRequestBuilder(hrfeed hrfeed: NSURL? = nil) -> RequestBuilder<ResponseMessage> {
        let path = "/institution/hrfeed/upload"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "hrfeed": hrfeed
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ResponseMessage>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Account Institution User
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateAccountInstitutionUser(accountId accountId: Int64, completion: ((data: User?, error: ErrorType?) -> Void)) {
        privateAccountInstitutionUserWithRequestBuilder(accountId: accountId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution User
     - GET /account/institution/users/{accountId}
     - Retrieve institution user information using the account_id
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter accountId: (path) Account identifier the user is associated to 

     - returns: RequestBuilder<User> 
     */
    public class func privateAccountInstitutionUserWithRequestBuilder(accountId accountId: Int64) -> RequestBuilder<User> {
        var path = "/account/institution/users/{accountId}"
        path = path.stringByReplacingOccurrencesOfString("{account_id}", withString: "\(accountId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<User>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Categories
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateCategoriesList(completion: ((data: [Category]?, error: ErrorType?) -> Void)) {
        privateCategoriesListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Categories
     - GET /account/categories
     - List institution categories (including parent Categories)
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[Category]> 
     */
    public class func privateCategoriesListWithRequestBuilder() -> RequestBuilder<[Category]> {
        let path = "/account/categories"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Category]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Institution Group Embargo Options
     
     - parameter groupId: (path) Group identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateGroupEmbargoOptionsDetails(groupId groupId: Int64, completion: ((data: [GroupEmbargoOptions]?, error: ErrorType?) -> Void)) {
        privateGroupEmbargoOptionsDetailsWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution Group Embargo Options
     - GET /account/institution/groups/{groupId}/embargo_options
     - Account institution group embargo options details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter groupId: (path) Group identifier 

     - returns: RequestBuilder<[GroupEmbargoOptions]> 
     */
    public class func privateGroupEmbargoOptionsDetailsWithRequestBuilder(groupId groupId: Int64) -> RequestBuilder<[GroupEmbargoOptions]> {
        var path = "/account/institution/groups/{groupId}/embargo_options"
        path = path.stringByReplacingOccurrencesOfString("{group_id}", withString: "\(groupId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[GroupEmbargoOptions]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete Institution Account Group Role
     
     - parameter accountId: (path) Account identifier for which to remove the role 
     - parameter groupId: (path) Group identifier for which to remove the role 
     - parameter roleId: (path) Role identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountGroupRoleDelete(accountId accountId: Int64, groupId: Int64, roleId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateInstitutionAccountGroupRoleDeleteWithRequestBuilder(accountId: accountId, groupId: groupId, roleId: roleId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete Institution Account Group Role
     - DELETE /account/institution/roles/{accountId}/{groupId}/{roleId}
     - Delete Institution Account Group Role
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter accountId: (path) Account identifier for which to remove the role 
     - parameter groupId: (path) Group identifier for which to remove the role 
     - parameter roleId: (path) Role identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateInstitutionAccountGroupRoleDeleteWithRequestBuilder(accountId accountId: Int64, groupId: Int64, roleId: Int64) -> RequestBuilder<Void> {
        var path = "/account/institution/roles/{accountId}/{groupId}/{roleId}"
        path = path.stringByReplacingOccurrencesOfString("{account_id}", withString: "\(accountId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{group_id}", withString: "\(groupId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{role_id}", withString: "\(roleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List Institution Account Group Roles
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountGroupRoles(accountId accountId: Int64, completion: ((data: AccountGroupRoles?, error: ErrorType?) -> Void)) {
        privateInstitutionAccountGroupRolesWithRequestBuilder(accountId: accountId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List Institution Account Group Roles
     - GET /account/institution/roles/{accountId}
     - List Institution Account Group Roles
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter accountId: (path) Account identifier the user is associated to 

     - returns: RequestBuilder<AccountGroupRoles> 
     */
    public class func privateInstitutionAccountGroupRolesWithRequestBuilder(accountId accountId: Int64) -> RequestBuilder<AccountGroupRoles> {
        var path = "/account/institution/roles/{accountId}"
        path = path.stringByReplacingOccurrencesOfString("{account_id}", withString: "\(accountId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<AccountGroupRoles>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Add Institution Account Group Roles
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter account: (body) Account description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountGroupRolesCreate(accountId accountId: Int64, account: AccountGroupRolesCreate, completion: ((error: ErrorType?) -> Void)) {
        privateInstitutionAccountGroupRolesCreateWithRequestBuilder(accountId: accountId, account: account).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Add Institution Account Group Roles
     - POST /account/institution/roles/{accountId}
     - Add Institution Account Group Roles
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter account: (body) Account description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateInstitutionAccountGroupRolesCreateWithRequestBuilder(accountId accountId: Int64, account: AccountGroupRolesCreate) -> RequestBuilder<Void> {
        var path = "/account/institution/roles/{accountId}"
        path = path.stringByReplacingOccurrencesOfString("{account_id}", withString: "\(accountId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = account.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create new Institution Account
     
     - parameter account: (body) Account description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountsCreate(account account: AccountCreate, completion: ((error: ErrorType?) -> Void)) {
        privateInstitutionAccountsCreateWithRequestBuilder(account: account).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Create new Institution Account
     - POST /account/institution/accounts
     - Create a new Account by sending account information
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter account: (body) Account description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateInstitutionAccountsCreateWithRequestBuilder(account account: AccountCreate) -> RequestBuilder<Void> {
        let path = "/account/institution/accounts"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = account.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Institution Accounts
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter isActive: (query) Filter by active status (optional)
     - parameter institutionUserId: (query) Filter by institution_user_id (optional)
     - parameter email: (query) Filter by email (optional)
     - parameter idLte: (query) Retrieve accounts with an ID lower or equal to the specified value (optional)
     - parameter idGte: (query) Retrieve accounts with an ID greater or equal to the specified value (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountsList(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, isActive: Int64? = nil, institutionUserId: String? = nil, email: String? = nil, idLte: Int64? = nil, idGte: Int64? = nil, completion: ((data: [ShortAccount]?, error: ErrorType?) -> Void)) {
        privateInstitutionAccountsListWithRequestBuilder(page: page, pageSize: pageSize, limit: limit, offset: offset, isActive: isActive, institutionUserId: institutionUserId, email: email, idLte: idLte, idGte: idGte).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution Accounts
     - GET /account/institution/accounts
     - Returns the accounts for which the account has administrative privileges (assigned and inherited).
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter isActive: (query) Filter by active status (optional)
     - parameter institutionUserId: (query) Filter by institution_user_id (optional)
     - parameter email: (query) Filter by email (optional)
     - parameter idLte: (query) Retrieve accounts with an ID lower or equal to the specified value (optional)
     - parameter idGte: (query) Retrieve accounts with an ID greater or equal to the specified value (optional)

     - returns: RequestBuilder<[ShortAccount]> 
     */
    public class func privateInstitutionAccountsListWithRequestBuilder(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, isActive: Int64? = nil, institutionUserId: String? = nil, email: String? = nil, idLte: Int64? = nil, idGte: Int64? = nil) -> RequestBuilder<[ShortAccount]> {
        let path = "/account/institution/accounts"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON(),
            "is_active": isActive?.encodeToJSON(),
            "institution_user_id": institutionUserId,
            "email": email,
            "id_lte": idLte?.encodeToJSON(),
            "id_gte": idGte?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ShortAccount]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Account Institution Accounts Search
     
     - parameter search: (body) Search Parameters 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountsSearch(search search: InstitutionAccountsSearch, completion: ((data: [ShortAccount]?, error: ErrorType?) -> Void)) {
        privateInstitutionAccountsSearchWithRequestBuilder(search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution Accounts Search
     - POST /account/institution/accounts/search
     - Returns the accounts for which the account has administrative privileges (assigned and inherited).
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter search: (body) Search Parameters 

     - returns: RequestBuilder<[ShortAccount]> 
     */
    public class func privateInstitutionAccountsSearchWithRequestBuilder(search search: InstitutionAccountsSearch) -> RequestBuilder<[ShortAccount]> {
        let path = "/account/institution/accounts/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ShortAccount]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update Institution Account
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter account: (body) Account description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionAccountsUpdate(accountId accountId: Int64, account: AccountUpdate, completion: ((error: ErrorType?) -> Void)) {
        privateInstitutionAccountsUpdateWithRequestBuilder(accountId: accountId, account: account).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update Institution Account
     - PUT /account/institution/accounts/{accountId}
     - Update Institution Account
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter accountId: (path) Account identifier the user is associated to 
     - parameter account: (body) Account description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateInstitutionAccountsUpdateWithRequestBuilder(accountId accountId: Int64, account: AccountUpdate) -> RequestBuilder<Void> {
        var path = "/account/institution/accounts/{accountId}"
        path = path.stringByReplacingOccurrencesOfString("{account_id}", withString: "\(accountId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = account.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     * enum for parameter order
     */
    public enum Order_privateInstitutionArticles: String { 
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
        case Shares = "shares"
        case Downloads = "downloads"
        case Cites = "cites"
    }

    /**
     * enum for parameter orderDirection
     */
    public enum OrderDirection_privateInstitutionArticles: String { 
        case Asc = "asc"
        case Desc = "desc"
    }

    /**
     Private Institution Articles
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter modifiedSince: (query) Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter status: (query) only return collections with this status (optional)
     - parameter resourceDoi: (query) only return collections with this resource_doi (optional)
     - parameter itemType: (query) Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionArticles(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_privateInstitutionArticles? = nil, orderDirection: OrderDirection_privateInstitutionArticles? = nil, publishedSince: String? = nil, modifiedSince: String? = nil, status: Int64? = nil, resourceDoi: String? = nil, itemType: Int64? = nil, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        privateInstitutionArticlesWithRequestBuilder(page: page, pageSize: pageSize, limit: limit, offset: offset, order: order, orderDirection: orderDirection, publishedSince: publishedSince, modifiedSince: modifiedSince, status: status, resourceDoi: resourceDoi, itemType: itemType).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Institution Articles
     - GET /account/institution/articles
     - Get Articles from own institution. User must be administrator of the institution
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter modifiedSince: (query) Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter status: (query) only return collections with this status (optional)
     - parameter resourceDoi: (query) only return collections with this resource_doi (optional)
     - parameter itemType: (query) Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)

     - returns: RequestBuilder<[Article]> 
     */
    public class func privateInstitutionArticlesWithRequestBuilder(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_privateInstitutionArticles? = nil, orderDirection: OrderDirection_privateInstitutionArticles? = nil, publishedSince: String? = nil, modifiedSince: String? = nil, status: Int64? = nil, resourceDoi: String? = nil, itemType: Int64? = nil) -> RequestBuilder<[Article]> {
        let path = "/account/institution/articles"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON(),
            "order": order?.rawValue,
            "order_direction": orderDirection?.rawValue,
            "published_since": publishedSince,
            "modified_since": modifiedSince,
            "status": status?.encodeToJSON(),
            "resource_doi": resourceDoi,
            "item_type": itemType?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Account Institutions
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionDetails(completion: ((data: Institution?, error: ErrorType?) -> Void)) {
        privateInstitutionDetailsWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institutions
     - GET /account/institution
     - Account institution details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]

     - returns: RequestBuilder<Institution> 
     */
    public class func privateInstitutionDetailsWithRequestBuilder() -> RequestBuilder<Institution> {
        let path = "/account/institution"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Institution>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Institution embargo options
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionEmbargoOptionsDetails(completion: ((data: [GroupEmbargoOptions]?, error: ErrorType?) -> Void)) {
        privateInstitutionEmbargoOptionsDetailsWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution embargo options
     - GET /account/institution/embargo_options
     - Account institution embargo options details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[GroupEmbargoOptions]> 
     */
    public class func privateInstitutionEmbargoOptionsDetailsWithRequestBuilder() -> RequestBuilder<[GroupEmbargoOptions]> {
        let path = "/account/institution/embargo_options"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[GroupEmbargoOptions]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Institution Groups
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionGroupsList(completion: ((data: [Group]?, error: ErrorType?) -> Void)) {
        privateInstitutionGroupsListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution Groups
     - GET /account/institution/groups
     - Returns the groups for which the account has administrative privileges (assigned and inherited).
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[Group]> 
     */
    public class func privateInstitutionGroupsListWithRequestBuilder() -> RequestBuilder<[Group]> {
        let path = "/account/institution/groups"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Group]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Institution Roles
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateInstitutionRolesList(completion: ((data: [Role]?, error: ErrorType?) -> Void)) {
        privateInstitutionRolesListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Institution Roles
     - GET /account/institution/roles
     - Returns the roles available for groups and the institution group.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[Role]> 
     */
    public class func privateInstitutionRolesListWithRequestBuilder() -> RequestBuilder<[Role]> {
        let path = "/account/institution/roles"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Role]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
