//
// OtherAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class OtherAPI: APIBase {
    /**
     Public Categories
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func categoriesList(completion: ((data: [Category]?, error: ErrorType?) -> Void)) {
        categoriesListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Categories
     - GET /categories
     - Returns a list of public categories
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[Category]> 
     */
    public class func categoriesListWithRequestBuilder() -> RequestBuilder<[Category]> {
        let path = "/categories"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Category]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Public File Download
     
     - parameter fileId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func fileDownload(fileId fileId: Int64, completion: ((error: ErrorType?) -> Void)) {
        fileDownloadWithRequestBuilder(fileId: fileId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Public File Download
     - GET /file/download/{fileId}
     - Starts the download of a file
     
     - parameter fileId: (path)  

     - returns: RequestBuilder<Void> 
     */
    public class func fileDownloadWithRequestBuilder(fileId fileId: Int64) -> RequestBuilder<Void> {
        var path = "/file/download/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Item Types
     
     - parameter groupId: (query) Identifier of the group for which the item types are requested (optional, default to 0)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func itemTypesList(groupId groupId: Int64? = nil, completion: ((data: [ItemType]?, error: ErrorType?) -> Void)) {
        itemTypesListWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Item Types
     - GET /item_types
     - Returns the list of Item Types of the requested group. If no user is authenticated, returns the item types available for Figshare.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter groupId: (query) Identifier of the group for which the item types are requested (optional, default to 0)

     - returns: RequestBuilder<[ItemType]> 
     */
    public class func itemTypesListWithRequestBuilder(groupId groupId: Int64? = nil) -> RequestBuilder<[ItemType]> {
        let path = "/item_types"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "group_id": groupId?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ItemType]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Public Licenses
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func licensesList(completion: ((data: [License]?, error: ErrorType?) -> Void)) {
        licensesListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Licenses
     - GET /licenses
     - Returns a list of public licenses
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[License]> 
     */
    public class func licensesListWithRequestBuilder() -> RequestBuilder<[License]> {
        let path = "/licenses"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[License]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account information
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateAccount(completion: ((data: Account?, error: ErrorType?) -> Void)) {
        privateAccountWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account information
     - GET /account
     - Account information for token/personal token
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]

     - returns: RequestBuilder<Account> 
     */
    public class func privateAccountWithRequestBuilder() -> RequestBuilder<Account> {
        let path = "/account"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Account>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Search Funding
     
     - parameter search: (body) Search Parameters (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateFundingSearch(search search: FundingSearch? = nil, completion: ((data: [FundingInformation]?, error: ErrorType?) -> Void)) {
        privateFundingSearchWithRequestBuilder(search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Search Funding
     - POST /account/funding/search
     - Search for fundings
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter search: (body) Search Parameters (optional)

     - returns: RequestBuilder<[FundingInformation]> 
     */
    public class func privateFundingSearchWithRequestBuilder(search search: FundingSearch? = nil) -> RequestBuilder<[FundingInformation]> {
        let path = "/account/funding/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[FundingInformation]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Account Licenses
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateLicensesList(completion: ((data: [License]?, error: ErrorType?) -> Void)) {
        privateLicensesListWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Account Licenses
     - GET /account/licenses
     - This is a private endpoint that requires OAuth. It will return a list with figshare public licenses AND licenses defined for account's institution.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]

     - returns: RequestBuilder<[License]> 
     */
    public class func privateLicensesListWithRequestBuilder() -> RequestBuilder<[License]> {
        let path = "/account/licenses"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[License]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
