//
// ProjectsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class ProjectsAPI: APIBase {
    /**
     Delete project article
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticleDelete(projectId projectId: Int64, articleId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateProjectArticleDeleteWithRequestBuilder(projectId: projectId, articleId: articleId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete project article
     - DELETE /account/projects/{projectId}/articles/{articleId}
     - Delete project article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectArticleDeleteWithRequestBuilder(projectId projectId: Int64, articleId: Int64) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Project article details
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticleDetails(projectId projectId: Int64, articleId: Int64, completion: ((data: ProjectArticle?, error: ErrorType?) -> Void)) {
        privateProjectArticleDetailsWithRequestBuilder(projectId: projectId, articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Project article details
     - GET /account/projects/{projectId}/articles/{articleId}
     - Project article details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 

     - returns: RequestBuilder<ProjectArticle> 
     */
    public class func privateProjectArticleDetailsWithRequestBuilder(projectId projectId: Int64, articleId: Int64) -> RequestBuilder<ProjectArticle> {
        var path = "/account/projects/{projectId}/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ProjectArticle>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Project article file details
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 
     - parameter fileId: (path) File unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticleFile(projectId projectId: Int64, articleId: Int64, fileId: Int64, completion: ((data: PrivateFile?, error: ErrorType?) -> Void)) {
        privateProjectArticleFileWithRequestBuilder(projectId: projectId, articleId: articleId, fileId: fileId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Project article file details
     - GET /account/projects/{projectId}/articles/{articleId}/files/{fileId}
     - Project article file details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 
     - parameter fileId: (path) File unique identifier 

     - returns: RequestBuilder<PrivateFile> 
     */
    public class func privateProjectArticleFileWithRequestBuilder(projectId projectId: Int64, articleId: Int64, fileId: Int64) -> RequestBuilder<PrivateFile> {
        var path = "/account/projects/{projectId}/articles/{articleId}/files/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PrivateFile>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Project article list files
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticleFiles(projectId projectId: Int64, articleId: Int64, completion: ((data: [PrivateFile]?, error: ErrorType?) -> Void)) {
        privateProjectArticleFilesWithRequestBuilder(projectId: projectId, articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Project article list files
     - GET /account/projects/{projectId}/articles/{articleId}/files
     - List article files
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter articleId: (path) Project Article unique identifier 

     - returns: RequestBuilder<[PrivateFile]> 
     */
    public class func privateProjectArticleFilesWithRequestBuilder(projectId projectId: Int64, articleId: Int64) -> RequestBuilder<[PrivateFile]> {
        var path = "/account/projects/{projectId}/articles/{articleId}/files"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[PrivateFile]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create project article
     
     - parameter projectId: (path) Project unique identifier 
     - parameter article: (body) Article description 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticlesCreate(projectId projectId: Int64, article: ArticleProjectCreate, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: Location?, error: ErrorType?) -> Void)) {
        privateProjectArticlesCreateWithRequestBuilder(projectId: projectId, article: article, page: page, pageSize: pageSize, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Create project article
     - POST /account/projects/{projectId}/articles
     - Create a new Article and associate it with this project
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter article: (body) Article description 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<Location> 
     */
    public class func privateProjectArticlesCreateWithRequestBuilder(projectId projectId: Int64, article: ArticleProjectCreate, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<Location> {
        var path = "/account/projects/{projectId}/articles"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = article.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Location>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     List project articles
     
     - parameter projectId: (path) Project unique identifier 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectArticlesList(projectId projectId: Int64, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        privateProjectArticlesListWithRequestBuilder(projectId: projectId, page: page, pageSize: pageSize, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List project articles
     - GET /account/projects/{projectId}/articles
     - List project articles
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<[Article]> 
     */
    public class func privateProjectArticlesListWithRequestBuilder(projectId projectId: Int64, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<[Article]> {
        var path = "/account/projects/{projectId}/articles"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Remove project collaborator
     
     - parameter projectId: (path) Project unique identifier 
     - parameter userId: (path) User unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectCollaboratorDelete(projectId projectId: Int64, userId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateProjectCollaboratorDeleteWithRequestBuilder(projectId: projectId, userId: userId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Remove project collaborator
     - DELETE /account/projects/{projectId}/collaborators/{userId}
     - Remove project collaborator
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter projectId: (path) Project unique identifier 
     - parameter userId: (path) User unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectCollaboratorDeleteWithRequestBuilder(projectId projectId: Int64, userId: Int64) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}/collaborators/{userId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{user_id}", withString: "\(userId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Invite project collaborators
     
     - parameter projectId: (path) Project unique identifier 
     - parameter collaborator: (body) viewer or collaborator role. User user_id or email of user 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectCollaboratorsInvite(projectId projectId: Int64, collaborator: ProjectCollaboratorInvite, completion: ((data: ResponseMessage?, error: ErrorType?) -> Void)) {
        privateProjectCollaboratorsInviteWithRequestBuilder(projectId: projectId, collaborator: collaborator).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Invite project collaborators
     - POST /account/projects/{projectId}/collaborators
     - Invite users to collaborate on project or view the project
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter collaborator: (body) viewer or collaborator role. User user_id or email of user 

     - returns: RequestBuilder<ResponseMessage> 
     */
    public class func privateProjectCollaboratorsInviteWithRequestBuilder(projectId projectId: Int64, collaborator: ProjectCollaboratorInvite) -> RequestBuilder<ResponseMessage> {
        var path = "/account/projects/{projectId}/collaborators"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = collaborator.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ResponseMessage>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List project collaborators
     
     - parameter projectId: (path) Project unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectCollaboratorsList(projectId projectId: Int64, completion: ((data: [ProjectCollaborator]?, error: ErrorType?) -> Void)) {
        privateProjectCollaboratorsListWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List project collaborators
     - GET /account/projects/{projectId}/collaborators
     - List Project collaborators and invited users
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter projectId: (path) Project unique identifier 

     - returns: RequestBuilder<[ProjectCollaborator]> 
     */
    public class func privateProjectCollaboratorsListWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<[ProjectCollaborator]> {
        var path = "/account/projects/{projectId}/collaborators"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ProjectCollaborator]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create project
     
     - parameter project: (body) Project  description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectCreate(project project: ProjectCreate, completion: ((data: CreateProjectResponse?, error: ErrorType?) -> Void)) {
        privateProjectCreateWithRequestBuilder(project: project).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Create project
     - POST /account/projects
     - Create a new project
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter project: (body) Project  description 

     - returns: RequestBuilder<CreateProjectResponse> 
     */
    public class func privateProjectCreateWithRequestBuilder(project project: ProjectCreate) -> RequestBuilder<CreateProjectResponse> {
        let path = "/account/projects"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = project.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<CreateProjectResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete project
     
     - parameter projectId: (path) Project unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectDelete(projectId projectId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateProjectDeleteWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete project
     - DELETE /account/projects/{projectId}
     - A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter projectId: (path) Project unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectDeleteWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     View project details
     
     - parameter projectId: (path) Project unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectDetails(projectId projectId: Int64, completion: ((data: ProjectCompletePrivate?, error: ErrorType?) -> Void)) {
        privateProjectDetailsWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     View project details
     - GET /account/projects/{projectId}
     - View a private project
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter projectId: (path) Project unique identifier 

     - returns: RequestBuilder<ProjectCompletePrivate> 
     */
    public class func privateProjectDetailsWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<ProjectCompletePrivate> {
        var path = "/account/projects/{projectId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ProjectCompletePrivate>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Project Leave
     
     - parameter projectId: (path) Project unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectLeave(projectId projectId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateProjectLeaveWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Private Project Leave
     - POST /account/projects/{projectId}/leave
     - Please note: project's owner cannot leave the project.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter projectId: (path) Project unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectLeaveWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}/leave"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Project note details
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectNote(projectId projectId: Int64, noteId: Int64, completion: ((data: ProjectNotePrivate?, error: ErrorType?) -> Void)) {
        privateProjectNoteWithRequestBuilder(projectId: projectId, noteId: noteId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Project note details
     - GET /account/projects/{projectId}/notes/{noteId}
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 

     - returns: RequestBuilder<ProjectNotePrivate> 
     */
    public class func privateProjectNoteWithRequestBuilder(projectId projectId: Int64, noteId: Int64) -> RequestBuilder<ProjectNotePrivate> {
        var path = "/account/projects/{projectId}/notes/{noteId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{note_id}", withString: "\(noteId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ProjectNotePrivate>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete project note
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectNoteDelete(projectId projectId: Int64, noteId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateProjectNoteDeleteWithRequestBuilder(projectId: projectId, noteId: noteId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete project note
     - DELETE /account/projects/{projectId}/notes/{noteId}
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectNoteDeleteWithRequestBuilder(projectId projectId: Int64, noteId: Int64) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}/notes/{noteId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{note_id}", withString: "\(noteId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update project note
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 
     - parameter note: (body) Note message 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectNoteUpdate(projectId projectId: Int64, noteId: Int64, note: ProjectNoteCreate, completion: ((error: ErrorType?) -> Void)) {
        privateProjectNoteUpdateWithRequestBuilder(projectId: projectId, noteId: noteId, note: note).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update project note
     - PUT /account/projects/{projectId}/notes/{noteId}
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter noteId: (path) Note unique identifier 
     - parameter note: (body) Note message 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectNoteUpdateWithRequestBuilder(projectId projectId: Int64, noteId: Int64, note: ProjectNoteCreate) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}/notes/{noteId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{note_id}", withString: "\(noteId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = note.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create project note
     
     - parameter projectId: (path) Project unique identifier 
     - parameter note: (body) Note message 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectNotesCreate(projectId projectId: Int64, note: ProjectNoteCreate, completion: ((data: Location?, error: ErrorType?) -> Void)) {
        privateProjectNotesCreateWithRequestBuilder(projectId: projectId, note: note).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Create project note
     - POST /account/projects/{projectId}/notes
     - Create a new project note
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter note: (body) Note message 

     - returns: RequestBuilder<Location> 
     */
    public class func privateProjectNotesCreateWithRequestBuilder(projectId projectId: Int64, note: ProjectNoteCreate) -> RequestBuilder<Location> {
        var path = "/account/projects/{projectId}/notes"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = note.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Location>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List project notes
     
     - parameter projectId: (path) Project unique identifier 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectNotesList(projectId projectId: Int64, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: [ProjectNote]?, error: ErrorType?) -> Void)) {
        privateProjectNotesListWithRequestBuilder(projectId: projectId, page: page, pageSize: pageSize, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List project notes
     - GET /account/projects/{projectId}/notes
     - List project notes
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<[ProjectNote]> 
     */
    public class func privateProjectNotesListWithRequestBuilder(projectId projectId: Int64, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<[ProjectNote]> {
        var path = "/account/projects/{projectId}/notes"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ProjectNote]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Project Publish
     
     - parameter projectId: (path) Project unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectPublish(projectId projectId: Int64, completion: ((data: ResponseMessage?, error: ErrorType?) -> Void)) {
        privateProjectPublishWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Project Publish
     - POST /account/projects/{projectId}/publish
     - Publish a project. Possible after all items inside it are public
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter projectId: (path) Project unique identifier 

     - returns: RequestBuilder<ResponseMessage> 
     */
    public class func privateProjectPublishWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<ResponseMessage> {
        var path = "/account/projects/{projectId}/publish"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ResponseMessage>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update project
     
     - parameter projectId: (path) Project unique identifier 
     - parameter project: (body) Project description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectUpdate(projectId projectId: Int64, project: ProjectUpdate, completion: ((error: ErrorType?) -> Void)) {
        privateProjectUpdateWithRequestBuilder(projectId: projectId, project: project).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update project
     - PUT /account/projects/{projectId}
     - Updating an project by passing body parameters; request can also be made with the PATCH method.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter projectId: (path) Project unique identifier 
     - parameter project: (body) Project description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateProjectUpdateWithRequestBuilder(projectId projectId: Int64, project: ProjectUpdate) -> RequestBuilder<Void> {
        var path = "/account/projects/{projectId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = project.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     * enum for parameter order
     */
    public enum Order_privateProjectsList: String { 
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
    }

    /**
     * enum for parameter orderDirection
     */
    public enum OrderDirection_privateProjectsList: String { 
        case Asc = "asc"
        case Desc = "desc"
    }

    /**
     * enum for parameter storage
     */
    public enum Storage_privateProjectsList: String { 
        case Group = "group"
        case Individual = "individual"
    }

    /**
     Private Projects
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter storage: (query) only return collections from this institution (optional)
     - parameter roles: (query) Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectsList(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_privateProjectsList? = nil, orderDirection: OrderDirection_privateProjectsList? = nil, storage: Storage_privateProjectsList? = nil, roles: String? = nil, completion: ((data: [ProjectPrivate]?, error: ErrorType?) -> Void)) {
        privateProjectsListWithRequestBuilder(page: page, pageSize: pageSize, limit: limit, offset: offset, order: order, orderDirection: orderDirection, storage: storage, roles: roles).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Projects
     - GET /account/projects
     - List private projects
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter storage: (query) only return collections from this institution (optional)
     - parameter roles: (query) Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)

     - returns: RequestBuilder<[ProjectPrivate]> 
     */
    public class func privateProjectsListWithRequestBuilder(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_privateProjectsList? = nil, orderDirection: OrderDirection_privateProjectsList? = nil, storage: Storage_privateProjectsList? = nil, roles: String? = nil) -> RequestBuilder<[ProjectPrivate]> {
        let path = "/account/projects"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON(),
            "order": order?.rawValue,
            "order_direction": orderDirection?.rawValue,
            "storage": storage?.rawValue,
            "roles": roles
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ProjectPrivate]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Projects search
     
     - parameter search: (body) Search Parameters (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateProjectsSearch(search search: ProjectsSearch? = nil, completion: ((data: [ProjectPrivate]?, error: ErrorType?) -> Void)) {
        privateProjectsSearchWithRequestBuilder(search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Projects search
     - POST /account/projects/search
     - Search inside the private projects
     - examples: [{contentType=application/json, example={}}]
     
     - parameter search: (body) Search Parameters (optional)

     - returns: RequestBuilder<[ProjectPrivate]> 
     */
    public class func privateProjectsSearchWithRequestBuilder(search search: ProjectsSearch? = nil) -> RequestBuilder<[ProjectPrivate]> {
        let path = "/account/projects/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ProjectPrivate]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Public Project Articles
     
     - parameter projectId: (path) Project Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func projectArticles(projectId projectId: Int64, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        projectArticlesWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Project Articles
     - GET /projects/{projectId}/articles
     - List articles in project
     - examples: [{contentType=application/json, example={}}]
     
     - parameter projectId: (path) Project Unique identifier 

     - returns: RequestBuilder<[Article]> 
     */
    public class func projectArticlesWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<[Article]> {
        var path = "/projects/{projectId}/articles"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Public Project
     
     - parameter projectId: (path) Project Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func projectDetails(projectId projectId: Int64, completion: ((data: ProjectComplete?, error: ErrorType?) -> Void)) {
        projectDetailsWithRequestBuilder(projectId: projectId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Project
     - GET /projects/{projectId}
     - View a project
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter projectId: (path) Project Unique identifier 

     - returns: RequestBuilder<ProjectComplete> 
     */
    public class func projectDetailsWithRequestBuilder(projectId projectId: Int64) -> RequestBuilder<ProjectComplete> {
        var path = "/projects/{projectId}"
        path = path.stringByReplacingOccurrencesOfString("{project_id}", withString: "\(projectId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ProjectComplete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     * enum for parameter order
     */
    public enum Order_projectsList: String { 
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
    }

    /**
     * enum for parameter orderDirection
     */
    public enum OrderDirection_projectsList: String { 
        case Asc = "asc"
        case Desc = "desc"
    }

    /**
     Public Projects
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter institution: (query) only return collections from this institution (optional)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter group: (query) only return collections from this group (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func projectsList(xCursor xCursor: NSUUID? = nil, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_projectsList? = nil, orderDirection: OrderDirection_projectsList? = nil, institution: Int64? = nil, publishedSince: String? = nil, group: Int64? = nil, completion: ((data: [Project]?, error: ErrorType?) -> Void)) {
        projectsListWithRequestBuilder(xCursor: xCursor, page: page, pageSize: pageSize, limit: limit, offset: offset, order: order, orderDirection: orderDirection, institution: institution, publishedSince: publishedSince, group: group).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Projects
     - GET /projects
     - Returns a list of public projects
     - responseHeaders: [X-Cursor(String)]
     - examples: [{contentType=application/json, example={}}]
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter institution: (query) only return collections from this institution (optional)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter group: (query) only return collections from this group (optional)

     - returns: RequestBuilder<[Project]> 
     */
    public class func projectsListWithRequestBuilder(xCursor xCursor: NSUUID? = nil, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_projectsList? = nil, orderDirection: OrderDirection_projectsList? = nil, institution: Int64? = nil, publishedSince: String? = nil, group: Int64? = nil) -> RequestBuilder<[Project]> {
        let path = "/projects"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON(),
            "order": order?.rawValue,
            "order_direction": orderDirection?.rawValue,
            "institution": institution?.encodeToJSON(),
            "published_since": publishedSince,
            "group": group?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
        let nillableHeaders: [String: AnyObject?] = [
            "X-Cursor": xCursor
        ]
        let headerParameters = APIHelper.rejectNilHeaders(nillableHeaders)
 
        let requestBuilder: RequestBuilder<[Project]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false, headers: headerParameters)
    }

    /**
     Public Projects Search
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter search: (body) Search Parameters (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func projectsSearch(xCursor xCursor: NSUUID? = nil, search: ProjectsSearch? = nil, completion: ((data: [Project]?, error: ErrorType?) -> Void)) {
        projectsSearchWithRequestBuilder(xCursor: xCursor, search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Projects Search
     - POST /projects/search
     - Returns a list of public articles
     - responseHeaders: [X-Cursor(String)]
     - examples: [{contentType=application/json, example={}}]
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter search: (body) Search Parameters (optional)

     - returns: RequestBuilder<[Project]> 
     */
    public class func projectsSearchWithRequestBuilder(xCursor xCursor: NSUUID? = nil, search: ProjectsSearch? = nil) -> RequestBuilder<[Project]> {
        let path = "/projects/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
        let nillableHeaders: [String: AnyObject?] = [
            "X-Cursor": xCursor
        ]
        let headerParameters = APIHelper.rejectNilHeaders(nillableHeaders)
 
        let requestBuilder: RequestBuilder<[Project]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true, headers: headerParameters)
    }

}
