//
// CommonSearch.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class CommonSearch: JSONEncodable {
    public enum OrderDirection: String { 
        case Asc = "asc"
        case Desc = "desc"
    }
    /** Search term */
    public var searchFor: String?
    /** Page number. Used for pagination with page_size */
    public var page: Int64?
    /** The number of results included on a page. Used for pagination with page */
    public var pageSize: Int64?
    /** Number of results included on a page. Used for pagination with query */
    public var limit: Int64?
    /** Where to start the listing(the offset of the first result). Used for pagination with limit */
    public var offset: Int64?
    /** Direction of ordering */
    public var orderDirection: OrderDirection?
    /** only return collections from this institution */
    public var institution: Int32?
    /** Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var publishedSince: String?
    /** Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var modifiedSince: String?
    /** only return collections from this group */
    public var group: Int32?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["search_for"] = self.searchFor
        nillableDictionary["page"] = self.page?.encodeToJSON()
        nillableDictionary["page_size"] = self.pageSize?.encodeToJSON()
        nillableDictionary["limit"] = self.limit?.encodeToJSON()
        nillableDictionary["offset"] = self.offset?.encodeToJSON()
        nillableDictionary["order_direction"] = self.orderDirection?.rawValue
        nillableDictionary["institution"] = self.institution?.encodeToJSON()
        nillableDictionary["published_since"] = self.publishedSince
        nillableDictionary["modified_since"] = self.modifiedSince
        nillableDictionary["group"] = self.group?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
