//
// PrivateAuthorsSearch.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class PrivateAuthorsSearch: JSONEncodable {
    public enum Order: String { 
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
        case Shares = "shares"
        case Downloads = "downloads"
        case Cites = "cites"
    }
    public enum OrderDirection: String { 
        case Asc = "asc"
        case Desc = "desc"
    }
    /** Search term */
    public var searchFor: String?
    /** Page number. Used for pagination with page_size */
    public var page: Int64?
    /** The number of results included on a page. Used for pagination with page */
    public var pageSize: Int64?
    /** Number of results included on a page. Used for pagination with query */
    public var limit: Int64?
    /** Where to start the listing(the offset of the first result). Used for pagination with limit */
    public var offset: Int64?
    /** The field by which to order. Default varies by endpoint/resource. */
    public var order: Order?
    /** Direction of ordering */
    public var orderDirection: OrderDirection?
    /** Return only authors associated to this institution */
    public var institutionId: Int64?
    /** Orcid of author */
    public var orcid: String?
    /** Return only authors in this group or subgroups of the group */
    public var groupId: Int64?
    /** Return only active authors if True */
    public var isActive: Bool?
    /** Return only authors that have published items if True */
    public var isPublic: Bool?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["search_for"] = self.searchFor
        nillableDictionary["page"] = self.page?.encodeToJSON()
        nillableDictionary["page_size"] = self.pageSize?.encodeToJSON()
        nillableDictionary["limit"] = self.limit?.encodeToJSON()
        nillableDictionary["offset"] = self.offset?.encodeToJSON()
        nillableDictionary["order"] = self.order?.rawValue
        nillableDictionary["order_direction"] = self.orderDirection?.rawValue
        nillableDictionary["institution_id"] = self.institutionId?.encodeToJSON()
        nillableDictionary["orcid"] = self.orcid
        nillableDictionary["group_id"] = self.groupId?.encodeToJSON()
        nillableDictionary["is_active"] = self.isActive
        nillableDictionary["is_public"] = self.isPublic
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
