//
// PrivateCollectionSearch.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class PrivateCollectionSearch: JSONEncodable {
    public enum Order: String { 
        case CreatedDate = "created_date"
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
        case Shares = "shares"
        case Cites = "cites"
    }
    public enum OrderDirection: String { 
        case Asc = "asc"
        case Desc = "desc"
    }
    /** Only return collections with this resource_doi */
    public var resourceDoi: String?
    /** Only return collections with this doi */
    public var doi: String?
    /** Only return collections with this handle */
    public var handle: String?
    /** The field by which to order. */
    public var order: Order?
    /** Search term */
    public var searchFor: String?
    /** Page number. Used for pagination with page_size */
    public var page: Int64?
    /** The number of results included on a page. Used for pagination with page */
    public var pageSize: Int64?
    /** Number of results included on a page. Used for pagination with query */
    public var limit: Int64?
    /** Where to start the listing(the offset of the first result). Used for pagination with limit */
    public var offset: Int64?
    /** Direction of ordering */
    public var orderDirection: OrderDirection?
    /** only return collections from this institution */
    public var institution: Int32?
    /** Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var publishedSince: String?
    /** Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var modifiedSince: String?
    /** only return collections from this group */
    public var group: Int32?
    /** only return collections with this resource_id */
    public var resourceId: String?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["resource_doi"] = self.resourceDoi
        nillableDictionary["doi"] = self.doi
        nillableDictionary["handle"] = self.handle
        nillableDictionary["order"] = self.order?.rawValue
        nillableDictionary["search_for"] = self.searchFor
        nillableDictionary["page"] = self.page?.encodeToJSON()
        nillableDictionary["page_size"] = self.pageSize?.encodeToJSON()
        nillableDictionary["limit"] = self.limit?.encodeToJSON()
        nillableDictionary["offset"] = self.offset?.encodeToJSON()
        nillableDictionary["order_direction"] = self.orderDirection?.rawValue
        nillableDictionary["institution"] = self.institution?.encodeToJSON()
        nillableDictionary["published_since"] = self.publishedSince
        nillableDictionary["modified_since"] = self.modifiedSince
        nillableDictionary["group"] = self.group?.encodeToJSON()
        nillableDictionary["resource_id"] = self.resourceId
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
