//
// ProjectCompletePrivate.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class ProjectCompletePrivate: JSONEncodable {
    public enum Role: String { 
        case Owner = "Owner"
        case Collaborator = "Collaborator"
        case Viewer = "Viewer"
    }
    public enum Storage: String { 
        case Individual = "individual"
        case Group = "group"
    }
    /** Role inside this project */
    public var role: Role?
    /** Project storage type */
    public var storage: Storage?
    /** Api endpoint */
    public var url: String?
    /** Project id */
    public var id: Int64?
    /** Project title */
    public var title: String?
    /** Project funding */
    public var funding: String?
    /** Full Project funding information */
    public var fundingList: [FundingInformation]?
    /** Project description */
    public var description: String?
    /** List of project collaborators */
    public var collaborators: [Collaborator]?
    /** Project quota */
    public var quota: Int64?
    /** Project used quota */
    public var usedQuota: Int64?
    /** Date when project was created */
    public var createdDate: String?
    /** Date when project was last modified */
    public var modifiedDate: String?
    /** Project private quota used */
    public var usedQuotaPrivate: Int64?
    /** Project public quota used */
    public var usedQuotaPublic: Int64?
    /** Group of project if any */
    public var groupId: Int64?
    /** ID of the account owning the project */
    public var accountId: Int64?
    /** Collection custom fields */
    public var customFields: [CustomArticleField]?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["role"] = self.role?.rawValue
        nillableDictionary["storage"] = self.storage?.rawValue
        nillableDictionary["url"] = self.url
        nillableDictionary["id"] = self.id?.encodeToJSON()
        nillableDictionary["title"] = self.title
        nillableDictionary["funding"] = self.funding
        nillableDictionary["funding_list"] = self.fundingList?.encodeToJSON()
        nillableDictionary["description"] = self.description
        nillableDictionary["collaborators"] = self.collaborators?.encodeToJSON()
        nillableDictionary["quota"] = self.quota?.encodeToJSON()
        nillableDictionary["used_quota"] = self.usedQuota?.encodeToJSON()
        nillableDictionary["created_date"] = self.createdDate
        nillableDictionary["modified_date"] = self.modifiedDate
        nillableDictionary["used_quota_private"] = self.usedQuotaPrivate?.encodeToJSON()
        nillableDictionary["used_quota_public"] = self.usedQuotaPublic?.encodeToJSON()
        nillableDictionary["group_id"] = self.groupId?.encodeToJSON()
        nillableDictionary["account_id"] = self.accountId?.encodeToJSON()
        nillableDictionary["custom_fields"] = self.customFields?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
