//
// RelatedMaterial.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class RelatedMaterial: JSONEncodable {
    public enum Relation: String { 
        case IsCitedBy = "IsCitedBy"
        case Cites = "Cites"
        case IsSupplementTo = "IsSupplementTo"
        case IsSupplementedBy = "IsSupplementedBy"
        case IsContinuedBy = "IsContinuedBy"
        case Continues = "Continues"
        case Describes = "Describes"
        case IsDescribedBy = "IsDescribedBy"
        case HasMetadata = "HasMetadata"
        case IsMetadataFor = "IsMetadataFor"
        case HasVersion = "HasVersion"
        case IsVersionOf = "IsVersionOf"
        case IsNewVersionOf = "IsNewVersionOf"
        case IsPreviousVersionOf = "IsPreviousVersionOf"
        case IsPartOf = "IsPartOf"
        case HasPart = "HasPart"
        case IsPublishedIn = "IsPublishedIn"
        case IsReferencedBy = "IsReferencedBy"
        case References = "References"
        case IsDocumentedBy = "IsDocumentedBy"
        case Documents = "Documents"
        case IsCompiledBy = "IsCompiledBy"
        case Compiles = "Compiles"
        case IsVariantFormOf = "IsVariantFormOf"
        case IsOriginalFormOf = "IsOriginalFormOf"
        case IsIdenticalTo = "IsIdenticalTo"
        case IsReviewedBy = "IsReviewedBy"
        case Reviews = "Reviews"
        case IsDerivedFrom = "IsDerivedFrom"
        case IsSourceOf = "IsSourceOf"
        case IsRequiredBy = "IsRequiredBy"
        case Requires = "Requires"
        case IsObsoletedBy = "IsObsoletedBy"
        case Obsoletes = "Obsoletes"
    }
    public enum IdentifierType: String { 
        case Ark = "ARK"
        case Arxiv = "arXiv"
        case Bibcode = "bibcode"
        case Doi = "DOI"
        case Ean13 = "EAN13"
        case Eissn = "EISSN"
        case Handle = "Handle"
        case Igsn = "IGSN"
        case Isbn = "ISBN"
        case Issn = "ISSN"
        case Istc = "ISTC"
        case Lissn = "LISSN"
        case Lsid = "LSID"
        case Pmid = "PMID"
        case Purl = "PURL"
        case Upc = "UPC"
        case Url = "URL"
        case Urn = "URN"
        case W3id = "w3id"
    }
    /** The ID of the related material; can be used to add existing materials of the same account to items. */
    public var id: Int64?
    /** The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material. */
    public var identifier: String?
    /** The related material title */
    public var title: String?
    /** The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material. */
    public var relation: Relation?
    /** The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material. */
    public var identifierType: IdentifierType?
    /** Flag for highlighting this related material in the call-out box */
    public var isLinkout: Bool?
    /** The full hyperlink for the identifier. Automatically generated by Figshare. */
    public var link: String?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["id"] = self.id?.encodeToJSON()
        nillableDictionary["identifier"] = self.identifier
        nillableDictionary["title"] = self.title
        nillableDictionary["relation"] = self.relation?.rawValue
        nillableDictionary["identifier_type"] = self.identifierType?.rawValue
        nillableDictionary["is_linkout"] = self.isLinkout
        nillableDictionary["link"] = self.link
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
